-------------------------------
-- SinStats HUD v1.8 by Sinba-Pagle
-------------------------------

local labelSpellCrit = ""
local talentMod = 0
local arcaneMod = 0
local aiMod = 0
local labelHit = ""
local hitMod = 0
local arcaneFocus = 0
local firepowerMod = 0
local apFire = 0
local pierceMod = 0
local apFrost = 0
local wisTalent = 0
local shadowMastery = 0
local emberstorm = 0
local vengeance = 0
local spiritualHealing = 0
local purification = 0
local dsImp = 0
local dsSuc = 0
local dmfbuff = 0
local className, classFilename, classId = UnitClass("player") 
local playerLevel = UnitLevel("player")
 
local function initSinStatsDB()
    if not SinStatsDB then
    SinStatsDB = {
        SinLockVar = true,
        SinHideVar = false,
		StatDirection = false,
    Stats = {
        AP = true,
        Crit = true,
        RangedCrit = false,
        SpellCrit = false,
        Hit = true,
		HasteMelee = true,
		HasteRanged = false,
		HasteCaster = false,
        RangedHit = false,
        SpellHit = false,
        DMG = true,
        RDMG = false,
        Healing = false,
        ManaRegen = false,
        CastingRegen = false,
        MP5Cast = false,
        Holy = false,
        Arcane = false,
        Fire = false,
        Nature = false,
        Frost = false,
        Shadow = false,
        Armor = false,
        Defense = false,
        Dodge = false,
        Parry = false,
        Block = false,
        Speed = true,
        FireResist = false,
        ShadowResist = false,
        FrostResist = false,
        NatureResist = false,
        RAP = false,
        Durability = true,
        apOption = true,
    },
    }   
    end
    if SinStatsDB.Stats.ManaRegen == nil then
        SinStatsDB.Stats.ManaRegen = false
    end
    if not SinStatsDB.StatFontSize  then
        SinStatsDB.StatFontSize  = 12
    end
    if not SinStatsDB.Stats.MP5Cast  then
        SinStatsDB.Stats.MP5Cast  = false
    end
    if not SinStatsDB.Stats.RDMG  then
        SinStatsDB.Stats.RDMG  = false
    end   
    if not SinStatsDB.Stats.FireResist  then
        SinStatsDB.Stats.FireResist  = false
    end   
    if not SinStatsDB.Stats.ShadowResist  then
        SinStatsDB.Stats.ShadowResist  = false
    end   
    if not SinStatsDB.Stats.FrostResist  then
        SinStatsDB.Stats.FrostResist  = false
    end   
    if not SinStatsDB.Stats.NatureResist  then
        SinStatsDB.Stats.NatureResist  = false
    end   
    if not SinStatsDB.Stats.DMGReduc  then
        SinStatsDB.Stats.DMGReduc  = false
    end  
    if not SinStatsDB.Stats.CastingRegen  then
        SinStatsDB.Stats.CastingRegen  = false
    end  
    if not SinStatsDB.Stats.MeleeMiss  then
        SinStatsDB.Stats.MeleeMiss  = false
    end 
    if not SinStatsDB.Stats.MeleeBoss then
        SinStatsDB.Stats.MeleeBoss  = false 
    end
    if not SinStatsDB.Stats.RangedMiss then
        SinStatsDB.Stats.RangedMiss  = false    
    end
    if not SinStatsDB.Stats.RangedBoss then
        SinStatsDB.Stats.RangedBoss  = false    
    end 
    if not SinStatsDB.Stats.SpellMiss then
        SinStatsDB.Stats.SpellMiss  = false 
    end
    if not SinStatsDB.Stats.SpellBoss then
        SinStatsDB.Stats.SpellBoss  = false 
    end 
    if not SinStatsDB.Stats.HasteMelee then
        SinStatsDB.Stats.HasteMelee  = true 
    end 	
    if not SinStatsDB.Stats.HasteRanged then
        SinStatsDB.Stats.HasteRanged  = false 
    end 	
    if not SinStatsDB.Stats.HasteCaster then
        SinStatsDB.Stats.HasteCaster  = false 
    end 	
end
 
local function talentScan()
 
local className, classFilename, classId = UnitClass("player")
 
    if (classFilename == "MAGE") then   
    local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 13)
        if points > 0 then
            talentMod = (points * 2)
        end
    local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 15)
        if points > 0 then
            arcaneMod = points * 1
            aiMod = ((points * 1)/100)
        end
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 3)
        if points > 0 then
            hitMod = points * 2
        end
    local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 2)
        if points > 0 then
            arcaneFocus = points * 2
            labelHit = (" (|cff69CCF0+" .. ("%.0f"):format(arcaneFocus) .. "|r)")   
        end     
    local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 15)      
        if points > 0 then
            firepowerMod = ((points * 2)/100)
        end     
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 8)
        if points > 0 then
            pierceMod = ((points * 2) / 100)
        end 
            
    elseif (classFilename == "PRIEST") then
    local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 3)
        if points > 0 then
            talentMod = points * 1
            labelSpellCrit = (" (|cffedede6+" .. ("%.0f"):format(talentMod) .. "|r)")
        end
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 5)
        if points > 0 then
            hitMod = points * 2
            labelHit = (" (|cff8787ED+" .. ("%.0f"):format(hitMod) .. "|r)")    
        end  
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 15)
        if points > 0 then
            DarkNessTalent = ((points * 2) / 100)
        end     
    local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 15)   
        if points > 0 then
            spiritualHealing = ((points * 2) / 100)
        end     
    
    elseif (classFilename == "PALADIN") then
    local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 10)
        if points > 0 then
            wisTalent = ((points * 10)/100)
        end 
        
    elseif (classFilename == "WARLOCK") then
    local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 16)
        if points > 0 then
            shadowMastery = ((points * 2)/100)
        end         
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 15)
        if points > 0 then
            emberstorm = ((points * 2)/100)
        end     
        
    elseif (classFilename == "SHAMAN") then
    local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 14)  
        if points > 0 then
            purification = ((points * 2)/100)
        end         
    
    end 
end
 
local function spellCheck()
    
    if (classFilename == "DRUID") then
    local index = GetShapeshiftForm()
        if (index == 1) or (index == 3) then
            return true
        else
            return false
        end
    end
    
    if (classFilename == "MAGE") then
    for i = 1, 40 do
        local _, _, count, _, _, _, _, _, _, spellId = UnitBuff("player",i, "PLAYER", "HELPFUL")
            if not spellId then break end
            if spellId == 12042 then
            return true
            end
    end
        return false
    end
    
    if (classFilename == "PALADIN") or (classFilename == "PRIEST") then
    for i = 1, 40 do
        local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")  
            if not spellId then break end   
            if spellId == 20218 then
            return true
            end
    end
        return false
    end 
    
end 
 
local function combustionSpell()
    if (classFilename == "MAGE") then
    for i = 1, 40 do
        local _, _, count, _, _, _, _, _, _, spellId = UnitBuff("player",i, "PLAYER", "HELPFUL")
            if not spellId then break end
            if spellId == 28682 then
                count = count * 10
                return count
            end
    end
    end
end

local function dmfDamage()
    if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") and (classFilename ~= "HUNTER") then
    for i = 1, 40 do
        local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")  
            if not spellId then break end   
            if spellId == 23768 then
                dmfbuff = 0.10
                return dmfbuff
            end
    end
    end
end
 
local function demonicSacrifice()
    if (classFilename == "WARLOCK") then
    for i = 1, 40 do
        local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "PLAYER", "HELPFUL")
            if not spellId then break end
            if spellId == 18791 then
                dsSuc = 0.15
                return dsSuc
            elseif spellId == 18789 then
                dsImp = 0.15
                return dsImp
            end
    end
    end
end
 
local function CreateConfig(statsframe)
-- Creating Settings Frame
local SinStatsConfig = CreateFrame("frame","SinStatsConfigFrame", UIParent, 'ShadowOverlayTemplate')
SinStatsConfig.StatsFrame = statsframe
-- Registering the frame
SinStatsConfig:RegisterEvent("ADDON_LOADED")
SinStatsConfig:RegisterEvent("PLAYER_LOGOUT")
-- Customizing the frame
SinStatsConfig:SetBackdrop({
bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
--edgeFile="Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
tile=1, tileSize=0, edgeSize=5,
 
 })
 -- SinStatsConfig.icon = SinStatsConfig:CreateTexture("BagBuddy_Icon", "BACKGROUND")
    -- SinStatsConfig.icon:SetWidth(59)
    -- SinStatsConfig.icon:SetHeight(59)
    -- SinStatsConfig.icon:SetPoint("TOPLEFT", -5, 7)
    -- SinStatsConfig.icon:SetTexture("Interface\\Icons\\Spell_nature_bloodlust")
    -- SetPortraitToTexture(SinStatsConfig.icon, "Interface\\Icons\\Spell_nature_bloodlust")

-- SinStatsConfig:SetBackdropBorderColor(0.5,0.5,0.5)
SinStatsConfig:SetBackdropColor(1,1,1,1)
SinStatsConfig:SetWidth(510)
SinStatsConfig:SetHeight(305)
SinStatsConfig:Hide()
SinStatsConfig:SetPoint("CENTER",UIParent)
SinStatsConfig:EnableMouse(true)
SinStatsConfig:SetMovable(true)
SinStatsConfig:RegisterForDrag("LeftButton")
SinStatsConfig:SetScript("OnDragStart", function(self) self:StartMoving() end)
SinStatsConfig:SetScript("OnDragStart", function(self) self:StartMoving() end)
SinStatsConfig:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
SinStatsConfig:SetFrameStrata("FULLSCREEN_DIALOG")
tinsert(UISpecialFrames, "SinStatsConfigFrame")
 
 
local slider = CreateFrame("Slider","SinStatsSlider",SinStatsConfig,'OptionsSliderTemplate')
getglobal(slider:GetName() .. 'Low'):SetText('9'); 
getglobal(slider:GetName() .. 'High'):SetText('20');   
getglobal(slider:GetName() .. 'Text'):SetText('Adjust HUD Text Size');
slider:SetMinMaxValues(9, 20)
slider:SetValueStep(1)
slider.slideTitle = slider:CreateFontString(nil, "OVERLAY");
slider.slideTitle:SetFontObject("GameFontHighlightSmall");
slider:SetScript("OnValueChanged", function (self)
local value = math.floor(self:GetValue())
SinStatsDB.StatFontSize  = value
SinStatsFrame:RestiseStats()
slider.slideTitle:SetText("Current: " .. SinStatsDB.StatFontSize )
end)
slider:SetValue(SinStatsDB.StatFontSize)
 
 
SinStatsConfig.SinTitle = SinStatsConfig:CreateFontString(nil, "OVERLAY");
SinStatsConfig.SinTitle:SetFontObject("GameFontHighlightLarge");
SinStatsConfig.SinTitle:SetPoint("TOP", SinStatsConfig, "TOP", 0, -3);
SinStatsConfig.SinTitle:SetText("|cff00c0ffSinStats HUD Settings|r");
 
SinStatsConfig.SigSection = SinStatsConfig:CreateFontString(nil, "OVERLAY");
SinStatsConfig.SigSection:SetFontObject("GameFontHighlightSmall");
SinStatsConfig.SigSection:SetPoint("BOTTOM", 0, 1);
SinStatsConfig.SigSection:SetText("|cff00c0ffby Sinba-Pagle | Release v1.8");
 
SinStatsConfig.SinClose = CreateFrame('Button', 'SinClose', SinStatsConfig, "UIPanelButtonTemplate")
SinStatsConfig.SinClose:SetPoint('BOTTOMRIGHT', -8,6)
SinStatsConfig.SinClose:SetSize(80, 20)
SinStatsConfig.SinClose:SetText("Save")
SinStatsConfig.SinClose:SetScript('OnClick', function(self)
self:GetParent():Hide()
end)
 
SinStatsConfig.SinXButton = CreateFrame('Button', 'SinXButton', SinStatsConfig, "UIPanelCloseButton")
SinStatsConfig.SinXButton:SetPoint('TOPRIGHT', 0,0)
SinStatsConfig.SinXButton:SetSize(25, 25)
SinStatsConfig.SinXButton:SetScript('OnClick', function(self)
self:GetParent():Hide()
end)
 
SinStatsConfig.SinReset = CreateFrame('Button', 'SinReset', SinStatsConfig, "UIPanelButtonTemplate")
SinStatsConfig.SinReset:SetPoint('BOTTOMLEFT', 5, 6)
SinStatsConfig.SinReset:SetSize(135, 20)
SinStatsConfig.SinReset:SetText("Reset HUD position")
SinStatsConfig.SinReset:SetScript('OnClick', function(self)
StaticPopup_Show("SINSTATS_HUD_RESET")
end)
 
local ChkBoxVar = CreateFrame("CheckButton", "$parentSinLockFrame", SinStatsConfig, "ChatConfigCheckButtonTemplate")
ChkBoxVar.LockFr = ChkBoxVar:CreateFontString(nil, "OVERLAY");
ChkBoxVar.LockFr:SetFontObject("GameFontHighlight");
ChkBoxVar.LockFr:SetPoint("LEFT", ChkBoxVar, "RIGHT", 5, 0);
ChkBoxVar.tooltip = "Lock the Stats Frame"
ChkBoxVar:SetScript('OnClick', function(self)
        local SinStats = SinStatsFrame
        SinStatsDB.SinLockVar = self:GetChecked()
        ChkBoxVar.LockFr:SetText(SinStatsDB.SinLockVar and "Stats HUD [|cffd4080cLocked|r]" or "Stats HUD [|cff00f26dUnlocked|r]")        
        local parent = self:GetParent()
        if SinStatsDB.SinLockVar == true then
        SinStats:SetUserPlaced(true)
        SinStats:SetMovable(true);
        SinStats:EnableMouse(false);       
        SinStats:SetUserPlaced(true)       
        SinStats:SetBackdropColor(1,1,1,0)
        elseif SinStatsDB.SinHideVar == true and not SinStatsDB.SinLockVar then
        SinStats:SetMovable(true);
        SinStats:EnableMouse(true);
        SinStats:SetUserPlaced(true);
        SinStats:SetBackdropColor(1,1,1,0)
        elseif not SinStatsDB.SinLockVar then
        SinStats:SetMovable(true);
        SinStats:EnableMouse(true);
        SinStats:SetUserPlaced(true);      
        SinStats:SetBackdropColor(1,1,1,1)
        end
        end)
    ChkBoxVar:SetChecked(SinStatsDB.SinLockVar)
    ChkBoxVar:GetScript('OnClick')(ChkBoxVar)
 
local HideBoxVar = CreateFrame("CheckButton", "$parentSinStatsHide", SinStatsConfig, "ChatConfigCheckButtonTemplate")
HideBoxVar.HideFr = HideBoxVar:CreateFontString(nil, "OVERLAY");
HideBoxVar.HideFr:SetFontObject("GameFontHighlight");
HideBoxVar.HideFr:SetPoint("LEFT", HideBoxVar, "RIGHT", 5, 0);
    HideBoxVar.tooltip = "Disable the Stats Frame"
    HideBoxVar:SetScript('OnClick', function(self)
        local Parent = self:GetParent()
        local SinStats = SinStatsFrame
        SinStatsDB.SinHideVar = self:GetChecked()
        HideBoxVar.HideFr:SetText(SinStatsDB.SinHideVar and "Stats HUD [|cffd4080cDisabled|r]" or "Stats HUD [|cff00f26dEnabled|r]")
        if SinStatsDB.SinHideVar then
            SinStats:Hide()
        elseif not SinStatsDB.SinHideVar and not SinStatsDB.SinLockVar then
            SinStats:Show()
        else
            SinStats:Show()
        end
    end)
    HideBoxVar:SetChecked(SinStatsDB.SinHideVar)
    HideBoxVar:GetScript('OnClick')(HideBoxVar)
	
local textAlign
local StatDirection = CreateFrame("CheckButton", "$parentSinStatsHide", SinStatsConfig, "ChatConfigCheckButtonTemplate")
StatDirection.HorVer = StatDirection:CreateFontString(nil, "OVERLAY");
StatDirection.HorVer:SetFontObject("GameFontHighlight");
StatDirection.HorVer:SetPoint("LEFT", StatDirection, "RIGHT", 5, 0);
StatDirection.tooltip = "Change the stat display text's alignment"
StatDirection:SetScript('OnClick', function(self)
local Parent = self:GetParent()
local SinStats = SinStatsFrame
SinStatsDB.SinDirection = self:GetChecked()
StatDirection.HorVer:SetText(SinStatsDB.SinDirection and "HUD Text Alignment [|cffd4080cHorizontal|r]" or "HUD Text Alignment [|cff00f26dVertical|r]")
	if SinStatsDB.SinDirection then	
		StaticPopup_Show("SINSTATS_APPLY_SETTINGS")
	else
		StaticPopup_Show("SINSTATS_APPLY_SETTINGS")
	end
end)
StatDirection:SetChecked(SinStatsDB.SinDirection)
StatDirection:GetScript('OnClick')(StatDirection)	
 
 
-----------------------------------------------------
-- Factory functions for creating check boxes
-----------------------------------------------------
 
    local function TabOnClick(self) 
        PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
        local ID = self:GetID()
        self:SetAlpha(1)
        self.widgets:Show()
        local parent = self:GetParent()
        for i=1, #parent.Tabs do
            if i ~= ID then
                parent.Tabs[i]:SetAlpha(0.5)
                parent.Tabs[i].widgets:Hide()
            end
        end
    end
     
    local function CreateTab(id, parent, text)
            local f = CreateFrame("Button", "$parentTab"..id, parent, "ConfigCategoryButtonTemplate")
            f:Hide()
            f:SetID(id)
            tinsert(parent.Tabs, f)
            f:SetText(text)
            local Text = _G[f:GetName().."NormalText"]
            Text:ClearAllPoints()
            Text:SetAllPoints()
            Text:SetJustifyH("CENTER")
    --  f:SetSize(Text:GetWidth() + 15 ,Text:GetHeight() + 10)
        local width = parent:GetWidth() - 20
        f:SetSize(width / 6, Text:GetHeight() + 10)
            f:SetHighlightTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
            if id == 1 then
                f:SetPoint("TOPLEFT",parent,"TOPLEFT", 0, 0)
            else
                f:SetPoint("LEFT",parent.Tabs[id-1],"RIGHT", 0, 0)
            end
            f.widgets = CreateFrame("Frame", nil, f)
            f.widgets:Hide()
            f.widgets:SetSize(parent:GetWidth(), parent:GetHeight() - f:GetHeight()) 
            f.widgets:SetPoint("TOPLEFT", parent.Tabs[1], "BOTTOMLEFT")
            f:SetScript("OnClick", TabOnClick)
            f:Show()
            return f
        end
 
    local function UpdateSetting(self)
        local Parent = SinStatsConfigFrame
        local StatsFrame = Parent.StatsFrame
        SinStatsDB.Stats[self.ID] = self:GetChecked()
        StatsFrame[self.ID]:SetShown(self:GetChecked())
        StatsFrame:redrawStats()
    end
 
    local function CreateCheckBox(parent, id, label)
        local f = CreateFrame("CheckButton", "$parent"..id, parent, "ChatConfigCheckButtonTemplate")
        f.Label = f:CreateFontString(nil, "OVERLAY");
        f.Label:SetFontObject("GameTooltipText");
        f.Label:SetPoint("LEFT", f, "RIGHT", 5, 0);
        f.Label:SetText(label)
        f.ID = id
        f:SetScript("OnClick", UpdateSetting)
        f:SetChecked(SinStatsDB.Stats[id])
        statsframe[id]:SetShown(SinStatsDB.Stats[id])
        return f
    end
    
    local f = SinStatsConfigFrame   
    f.Tabs = {}
    local TabSettings = SinStatsDB.Stats
    local tab = CreateTab(1, f, "HUD")
    
    tab:ClearAllPoints() 
    tab:SetPoint("TOPLEFT", 10, -40)
    
    local sheet = tab.widgets       
    
    sheet.General = sheet:CreateFontString(nil, "OVERLAY");
    sheet.General:SetFontObject("GameFontHighlightLarge");
    sheet.General:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.General:SetText("|cfff39c33HUD Settings|r");  
    
    ChkBoxVar:SetParent(sheet)
    ChkBoxVar:SetPoint('TOP', 0, -50)
    
    HideBoxVar:SetParent(sheet)
    HideBoxVar:SetPoint('TOPLEFT', 60, -50)
	
	StatDirection:SetParent(sheet)
	StatDirection:SetPoint('TOPLEFT', HideBoxVar, 'BOTTOMLEFT', 0, -5)
	
    slider:SetParent(sheet)	
	slider:SetPoint("CENTER",0,-12)
	slider.slideTitle:SetPoint("TOP", slider, "BOTTOM", 0, -10);		
    
    tab = CreateTab(2, f, "Melee")
    sheet = tab.widgets 
    
    sheet.MeleeStats = sheet:CreateFontString(nil, "OVERLAY");
    sheet.MeleeStats:SetFontObject("GameFontHighlightLarge");
    sheet.MeleeStats:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.MeleeStats:SetText("|cfff39c33Melee and Defense Stats|r");    
    
    sheet.AP = CreateCheckBox(sheet, "AP", "Attack Power")
    sheet.AP:SetPoint('TOPLEFT', 0, -50)      
    
    sheet.Crit = CreateCheckBox(sheet, "Crit", "Critical Strike")
    sheet.Crit:SetPoint('TOPLEFT', sheet.AP, "BOTTOMLEFT", 0, -5)
 
    sheet.Hit = CreateCheckBox(sheet, "Hit", "Hit")
    sheet.Hit:SetPoint('TOP', -40, -50)
 
    sheet.DMG = CreateCheckBox(sheet, "DMG", "Damage")
    sheet.DMG:SetPoint('TOPLEFT', sheet.Hit, "BOTTOMLEFT", 0, -5)   
    
    sheet.Armor = CreateCheckBox(sheet, "Armor", "Armor")
    sheet.Armor:SetPoint('TOPRIGHT', -110,-50)
 
    sheet.Defense = CreateCheckBox(sheet, "Defense", "Defense")
    sheet.Defense:SetPoint('TOPRIGHT', sheet.Armor, 'BOTTOMRIGHT', 0,-5)
 
    sheet.Dodge = CreateCheckBox(sheet, "Dodge", "Dodge")
    sheet.Dodge:SetPoint('TOPLEFT', sheet.Crit, 'BOTTOMLEFT', 0,-5)
 
    sheet.Parry = CreateCheckBox(sheet, "Parry", "Parry")
    sheet.Parry:SetPoint('TOP', sheet.DMG, 'BOTTOM', 0,-5)
 
    sheet.Block = CreateCheckBox(sheet, "Block", "Block")
    sheet.Block:SetPoint('TOPRIGHT', sheet.Defense, 'BOTTOMRIGHT', 0,-5)
    
    sheet.DMGReduc = CreateCheckBox(sheet, "DMGReduc", "Mitigation")
    sheet.DMGReduc:SetPoint('TOPLEFT', sheet.Dodge, 'BOTTOMLEFT', 0,-5)
    sheet.DMGReduc.tooltip = "Percentage of damage reduction against NPC of the same level"     
    
    sheet.MeleeMiss = CreateCheckBox(sheet, "MeleeMiss", "Miss Chance")
    sheet.MeleeMiss:SetPoint('TOP', sheet.Parry, 'BOTTOM', 0, -5)   
    sheet.MeleeMiss.tooltip = "Melee miss chance against NPC of the same level" 
    
    sheet.MeleeBoss = CreateCheckBox(sheet, "MeleeBoss", "Miss vs Boss")
    sheet.MeleeBoss:SetPoint('TOPRIGHT', sheet.Block, 'BOTTOMRIGHT', 0, -5)
    sheet.MeleeBoss.tooltip = "Melee miss chance against NPC of +3 levels"  

    sheet.HasteMelee = CreateCheckBox(sheet, "HasteMelee", "Haste")
    sheet.HasteMelee:SetPoint('TOPLEFT', sheet.DMGReduc, 'BOTTOMLEFT', 0, -5)
    sheet.HasteMelee.tooltip = "Haste bonus percentage from abilities procs, enchants, talents, trinkets, consumables, buffs and world buffs"    
 
    tab = CreateTab(3, f, "Ranged")
    sheet = tab.widgets 
    
    sheet.RangedStats = sheet:CreateFontString(nil, "OVERLAY");
    sheet.RangedStats:SetFontObject("GameFontHighlightLarge");
    sheet.RangedStats:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.RangedStats:SetText("|cfff39c33Ranged Stats|r");  
    
    sheet.RAP = CreateCheckBox(sheet, "RAP", "Attack Power")
    sheet.RAP:SetPoint('TOPLEFT',0,-50)
 
    sheet.RangedCrit = CreateCheckBox(sheet, "RangedCrit", "Critical Strike")
    sheet.RangedCrit:SetPoint('TOPLEFT', sheet.RAP, 'BOTTOMLEFT' , 0, -5)      

    sheet.HasteRanged = CreateCheckBox(sheet, "HasteRanged", "Haste")
    sheet.HasteRanged:SetPoint('TOPLEFT', sheet.RangedCrit, 'BOTTOMLEFT' , 0, -5)   	
    sheet.HasteRanged.tooltip = "Haste bonus percentage from abilities procs, enchants, talents, trinkets, consumables, buffs and world buffs" 	
   
    sheet.RDMG = CreateCheckBox(sheet, "RDMG", "Damage")
    sheet.RDMG:SetPoint('TOP', -40,-50)
 
    sheet.RangedMiss = CreateCheckBox(sheet, "RangedMiss", "Miss Chance")
    sheet.RangedMiss:SetPoint('TOP', sheet.RDMG, 'BOTTOM', 0,-5)    
    sheet.RangedMiss.tooltip = "Ranged miss chance against NPC of the same level"       
 
    sheet.RangedHit = CreateCheckBox(sheet, "RangedHit", "Hit")
    sheet.RangedHit:SetPoint('TOPRIGHT', -110,-50)
        
    sheet.RangedBoss = CreateCheckBox(sheet, "RangedBoss", "Miss vs Boss")
    sheet.RangedBoss:SetPoint('TOPRIGHT', sheet.RangedHit, 'BOTTOMRIGHT', 0,-5) 
    sheet.RangedBoss.tooltip = "Ranged miss chance against NPC of +3 levels"        
   
 
 
    tab = CreateTab(4, f, "Spell")
    sheet = tab.widgets
 
    sheet.SpellStats = sheet:CreateFontString(nil, "OVERLAY");
    sheet.SpellStats:SetFontObject("GameFontHighlightLarge");
    sheet.SpellStats:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.SpellStats:SetText("|cfff39c33Spell Stats|r");
 
    sheet.SpellCrit = CreateCheckBox(sheet, "SpellCrit", "Spell Critical Strike")
    sheet.SpellCrit:SetPoint('TOPLEFT', 0,-50)
    sheet.SpellCrit.tooltip = "Talent spell-specific Crit is colored (Grey = Priest's Holy Specialization)" 
 
    sheet.SpellHit = CreateCheckBox(sheet, "SpellHit", "Spell Hit")
    sheet.SpellHit:SetPoint('TOP', -40,-50)
    sheet.SpellHit.tooltip = "Talent spell-specific Hit is colored (Blue = Mage's Arcane Focus, Purple = Priest's Shadow Focus)"        
 
    sheet.Healing = CreateCheckBox(sheet, "Healing", "Healing Power")
    sheet.Healing:SetPoint('TOPRIGHT', -110,-50)
	sheet.Healing.tooltip = "Includes +healing from gear, consumables, enchants and talents"  
	
    sheet.Holy = CreateCheckBox(sheet, "Holy", "Holy Power")
    sheet.Holy:SetPoint('TOPLEFT', sheet.SpellCrit, "BOTTOMLEFT", 0,-5)
	sheet.Holy.tooltip = "Includes Holy damage from gear, consumables, enchants and talents"   
 
    sheet.Arcane = CreateCheckBox(sheet, "Arcane", "Arcane Power")
    sheet.Arcane:SetPoint('TOP', sheet.SpellHit, 'BOTTOM', 0,-5)
	sheet.Arcane.tooltip = "Includes Arcane damage from gear, consumables, enchants and talents" 	
 
    sheet.Fire = CreateCheckBox(sheet, "Fire", "Fire Power")
    sheet.Fire:SetPoint('TOPRIGHT', sheet.Healing, "BOTTOMRIGHT", 0,-5)
	sheet.Fire.tooltip = "Includes Fire damage from gear, consumables, enchants and talents" 	
 
    sheet.Nature = CreateCheckBox(sheet, "Nature", "Nature Power")
    sheet.Nature:SetPoint('TOPLEFT', sheet.Holy, "BOTTOMLEFT", 0,-5)
	sheet.Nature.tooltip = "Includes Nature damage from gear, consumables, enchants and talents" 	
 
    sheet.Frost = CreateCheckBox(sheet, "Frost", "Frost Power")
    sheet.Frost:SetPoint('TOP', sheet.Arcane, 'BOTTOM', 0,-5)
	sheet.Frost.tooltip = "Includes Frost damage from gear, consumables, enchants and talents" 	
 
    sheet.Shadow = CreateCheckBox(sheet, "Shadow", "Shadow Power")
    sheet.Shadow:SetPoint('TOPRIGHT', sheet.Fire, "BOTTOMRIGHT", 0,-5)	
	sheet.Shadow.tooltip = "Includes Shadow damage from gear, consumables, enchants and talents" 
   
    sheet.ManaRegen = CreateCheckBox(sheet, "ManaRegen", "Mana Regen")
    sheet.ManaRegen:SetPoint('TOPLEFT', sheet.Nature, "BOTTOMLEFT", 0,-5)
    sheet.ManaRegen.tooltip = "Mana Regen per tick while not casting"   
 
    sheet.SpellMiss = CreateCheckBox(sheet, "SpellMiss", "Miss Chance")
    sheet.SpellMiss:SetPoint('TOPLEFT', sheet.ManaRegen, "BOTTOMLEFT", 0,-5)
    sheet.SpellMiss.tooltip = "Spell miss chance against NPC of the same level" 
 
    sheet.CastingRegen = CreateCheckBox(sheet, "CastingRegen", "Casting Regen")
    sheet.CastingRegen:SetPoint('TOP', sheet.Frost, 'BOTTOM', 0,-5)
    sheet.CastingRegen.tooltip = "Mana Regen per tick while casting"

    sheet.SpellBoss = CreateCheckBox(sheet, "SpellBoss", "Miss vs Boss")
    sheet.SpellBoss:SetPoint('TOP', sheet.CastingRegen, 'BOTTOM', 0,-5)
    sheet.SpellBoss.tooltip = "Spell miss chance against NPC of +3 levels"  	
 
    sheet.MP5Cast = CreateCheckBox(sheet, "MP5Cast", "MP5")
    sheet.MP5Cast:SetPoint('TOPRIGHT', sheet.Shadow, "BOTTOMRIGHT", 0,-5)
    sheet.MP5Cast.tooltip = "MP5 value from gear, enchants, consumables and world buffs"   

	sheet.HasteCaster = CreateCheckBox(sheet, "HasteCaster", "Haste")
    sheet.HasteCaster:SetPoint('TOPRIGHT', sheet.MP5Cast, 'BOTTOMRIGHT' , 0, -5)   	
    sheet.HasteCaster.tooltip = "Haste bonus percentage from abilities procs, talents, trinkets, consumables, buffs and world buffs" 	
 
 
    tab = CreateTab(5, f, "Resistance")
    sheet = tab.widgets
    
    sheet.ResStats = sheet:CreateFontString(nil, "OVERLAY");
    sheet.ResStats:SetFontObject("GameFontHighlightLarge");
    sheet.ResStats:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.ResStats:SetText("|cfff39c33Resistance Stats|r");     
    
    sheet.FireResist = CreateCheckBox(sheet, "FireResist", "Fire")
    sheet.FireResist:SetPoint('TOPLEFT', 0,-50)
 
    sheet.FrostResist = CreateCheckBox(sheet, "FrostResist", "Frost")
    sheet.FrostResist:SetPoint('TOP', -40,-50)   
   
    sheet.ShadowResist = CreateCheckBox(sheet, "ShadowResist", "Shadow")
    sheet.ShadowResist:SetPoint('TOPRIGHT', -110,-50)
   
    sheet.NatureResist = CreateCheckBox(sheet, "NatureResist", "Nature")
    sheet.NatureResist:SetPoint('TOPLEFT', sheet.FireResist, "BOTTOMLEFT", 0,-5)    
    
    tab = CreateTab(6, f, "General")
    sheet = tab.widgets 
 
    sheet.SpellStats = sheet:CreateFontString(nil, "OVERLAY");
    sheet.SpellStats:SetFontObject("GameFontHighlightLarge");
    sheet.SpellStats:SetPoint("TOP", sheet, "TOP", 0, -20);
    sheet.SpellStats:SetText("|cfff39c33General Stats|r");
 
    sheet.Speed = CreateCheckBox(sheet, "Speed", "Movement Speed")
    sheet.Speed:SetPoint('TOPLEFT', 60,-50)
 
    sheet.Durability = CreateCheckBox(sheet, "Durability", "Durability")
    sheet.Durability:SetPoint('TOP', 0,-50)   
     
	TabOnClick(f.Tabs[1])

end
 
    ---------------------------------------
    -- Creating stats text inside the frame
    ---------------------------------------
local function SetFont(self)
    self:SetFont("Fonts\\ARIALN.ttf", SinStatsDB.StatFontSize, "OUTLINE")
end
     
local function CreateStatStrings(self)
    self.Texts = {}
local DisplayOrder = {
            "AP",
            "RAP",
            "DMG",
            "RDMG",
            "Crit",    
            "RangedCrit",
            "SpellCrit",
            "Hit",
            "RangedHit",			
			"HasteMelee",
            "MeleeMiss",
            "MeleeBoss",
			"HasteRanged",
            "RangedMiss",
            "RangedBoss",
            "SpellHit",
			"HasteCaster",
            "SpellMiss",
            "SpellBoss",
            "ManaRegen",
            "CastingRegen",
            "MP5Cast",         
            "Healing",
            "Holy",
            "Arcane",
            "Fire",
            "Nature",
            "Frost",
            "Shadow",
            "Armor",
            "DMGReduc",
            "Defense",
            "Dodge",
            "Parry",
            "Block",
            "FireResist",
            "FrostResist",
            "ShadowResist",         
            "NatureResist",        
            "Speed",
            "Durability",
    }
local function CreateText(parent, name)
local f = parent:CreateFontString("$parent"..name, "OVERLAY", "GameFontNormal")
    f:SetFont("Fonts\\ARIALN.ttf", 8, "OUTLINE")
    f:SetTextColor(1,1,1,1)
    tinsert(parent.Texts, f)
    f.ID = #parent.Texts
return f
end
for i=1, #DisplayOrder do
    if SinStatsDB and SinStatsDB.Stats[DisplayOrder[i]] == nil then
        print("|cffff0000SinsStats:|r Missing Saved Variable:|cff00ff00", DisplayOrder[i])
    end
        self[DisplayOrder[i]] = CreateText(self, DisplayOrder[i])
end
end
 
---------------------------
-- Creating the Stats Frame
---------------------------
local f
local SinStats = CreateFrame("frame", "SinStatsFrame", UIParent)
 
    function SinStats:RestiseStats()
        for i=1, #self.Texts do
            SetFont(self.Texts[i])
            end
    end
    CreateStatStrings(SinStats)
 
------------------------------
-- Registering the Stats Frame
------------------------------
SinStats:RegisterEvent("PLAYER_LOGIN")
SinStats:RegisterEvent("UNIT_STATS", "player")
SinStats:RegisterUnitEvent("UNIT_AURA", "player")
--SinStats:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
SinStats:RegisterEvent("CHARACTER_POINTS_CHANGED")
SinStats:RegisterEvent("BIND_ENCHANT")
SinStats:RegisterEvent("REPLACE_ENCHANT")
--SinStats:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
SinStats:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
SinStats:RegisterEvent("UNIT_RESISTANCES", "player")
SinStats:RegisterEvent("UNIT_DAMAGE")
SinStats:RegisterEvent("UNIT_RANGEDDAMAGE")
SinStats:RegisterEvent("UNIT_ATTACK_POWER")
SinStats:RegisterEvent("UNIT_RANGED_ATTACK_POWER")
SinStats:RegisterEvent("UNIT_DEFENSE")
SinStats:RegisterEvent("PLAYER_LEVEL_UP")
 
------------------------
-- Customizing the frame
------------------------
SinStats:SetBackdrop({
    bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
    tile=1, tileSize=0, edgeSize=0,
})
SinStats:SetBackdropColor(1,1,1,1)
SinStats:SetWidth(100)
SinStats:SetHeight(25)
SinStats:SetPoint("CENTER",UIParent)
SinStats:EnableMouse(false)
SinStats:SetMovable(true)
SinStats:SetUserPlaced(true)
SinStats:SetClampedToScreen(false)
SinStats:RegisterForDrag("LeftButton")
SinStats:SetScript("OnDragStart", function(self) self:StartMoving() end)
SinStats:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
SinStats:SetFrameStrata("BACKGROUND")
 
-------------------------------
-- Executing the stats OnUpdate
-------------------------------
local updatespeed = 1.2
local TimeToNextUpdate = updatespeed
SinStats:SetScript("OnUpdate", function (self, elapsed)
TimeToNextUpdate = TimeToNextUpdate - elapsed
if TimeToNextUpdate > 0 then return end
TimeToNextUpdate = updatespeed
 
        
-- Armor
local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player");
self.Armor:SetText("Armor: " .. effectiveArmor);
        
-- Mitigation
local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player");
local armorReduction = effectiveArmor/((85 * playerLevel) + 400);
armorReduction = 100 * (armorReduction/(armorReduction + 1));
self.DMGReduc:SetText("Mitigation: " .. ("%.0f"):format(armorReduction) .. "%");            
        
-- Melee Critical Strike
local critChance = GetCritChance("player");
self.Crit:SetText("Crit: " .. ("%.2f"):format(critChance) .. "%");
 
-- Spell Critical Strike
local critSpellChance = GetSpellCritChance("player");
if combustionSpell() then
    critSpellChance = critSpellChance + combustionSpell()
end
self.SpellCrit:SetText("Spell Crit: " .. ("%.2f"):format(critSpellChance + arcaneMod + talentMod) .. "%" .. labelSpellCrit);
 
-- Ranged Critical Strike
local critRangedChance = GetRangedCritChance("player");
self.RangedCrit:SetText("Ranged Crit: " .. ("%.2f"):format(critRangedChance) .. "%");
 
-- Melee Hit Chance
local hitChance = GetHitModifier("player");
self.Hit:SetText("Hit: " .. hitChance .. "%");
 
-- Melee Miss Chance
local meleeSameLevel = 0
local meleeBossLevel = 0
local mainBase, mainMod, offBase, offMod = UnitAttackBothHands("player")
local levelDefense = playerLevel * 5
local bossDefense = (playerLevel + 3) * 5
local mWeaponSkill = (mainBase + mainMod)
local shieldEquipped = IsEquippedItemType("Shields")
local itemId = GetInventoryItemID("player", 17);
local itemId2 = GetInventoryItemID("player", 16);
 
 
if itemId and itemId2 then
    if (classFilename == "WARRIOR") or (classFilename == "ROGUE") or (classFilename == "HUNTER") then
        meleeSameLevel = (24 + ((levelDefense - mWeaponSkill) * 0.1))
        meleeSameLevel = meleeSameLevel - hitChance
        meleeBossLevel = (26 + ((bossDefense - mWeaponSkill - 10) * 0.4))
        meleeBossLevel = meleeBossLevel - hitChance     
    end     
 
elseif (not itemId and itemId2) or (not itemId and not itemId2) then
    if spellCheck() then
        meleeSameLevel = 5 - hitChance
        meleeBossLevel = 9 - hitChance
    else
        meleeSameLevel = (5 + ((levelDefense - mWeaponSkill) * 0.1))
        meleeSameLevel = meleeSameLevel - hitChance
        meleeBossLevel = (7 + ((bossDefense - mWeaponSkill - 10) * 0.4))
        meleeBossLevel = meleeBossLevel - hitChance
    end
end
if shieldEquipped then
    if (classFilename == "WARRIOR") or (classFilename == "PALADIN") or (classFilename == "SHAMAN") then
        meleeSameLevel = (5 + ((levelDefense - mWeaponSkill) * 0.1))
        meleeSameLevel = meleeSameLevel - hitChance
        meleeBossLevel = (7 + ((bossDefense - mWeaponSkill - 10) * 0.4))
        meleeBossLevel = meleeBossLevel - hitChance
    end
end
if meleeSameLevel < 0 then
    meleeSameLevel = 0
elseif meleeSameLevel > 100 then
    meleeSameLevel = 100
end
if meleeBossLevel < 0 then
    meleeBossLevel = 0
elseif meleeBossLevel > 100 then
    meleeBossLevel = 100
end
self.MeleeMiss:SetText("Miss: " .. meleeSameLevel .. "%");
self.MeleeBoss:SetText("Miss+: " .. meleeBossLevel .. "%");
 
    
-- Ranged Hit Chance
local label, hitRangedChance, percentAdded = "Ranged Hit: ", 0, ""
if (classFilename == "HUNTER") then
local slotId = GetInventorySlotInfo("RangedSlot")
local link = GetInventoryItemLink("player", slotId)
    if link then
        hitRangedChance = GetHitModifier("player");
        local itemId, enchantId = link:match("item:(%d+):(%d+)")
            if enchantId then
                enchantId = tonumber(enchantId)
                    if enchantId == 2523 then
                        hitRangedmod = 3
                        hitRangedChance = hitRangedChance + 3
                        -- percentAdded = percentAdded .. " |cff00ff00+3% Scope"
                    end
            end
    end
self.RangedHit:SetText(label .. (hitRangedChance and hitRangedChance) .. "%"); 
else
hitRangedChance = GetHitModifier("player");
self.RangedHit:SetText(label .. hitRangedChance .. "%"); 
end
 
-- Ranged Miss Chance 
local rangedMissLevel = 0
local rangedMissBoss = 0
local rangedAttackBase, rangedAttackMod = UnitRangedAttack("player")
local levelDefense = playerLevel * 5
local bossDefense = (playerLevel + 3) * 5
local rWeaponSkill = (rangedAttackBase + rangedAttackMod)
 
rangedMissLevel = (5 + ((levelDefense - rWeaponSkill) * 0.1))
rangedMissLevel = rangedMissLevel - hitRangedChance
    if rangedMissLevel < 0 then
        rangedMissLevel = 0
    elseif rangedMissLevel > 100 then
        rangedMissLevel = 100
    end
self.RangedMiss:SetText("Ranged Miss: " .. rangedMissLevel .. "%");
 
rangedMissBoss = (7 + ((bossDefense - rWeaponSkill - 10) * 0.4))
rangedMissBoss = rangedMissBoss - hitRangedChance
    if rangedMissBoss < 0 then
    rangedMissBoss = 0
    elseif rangedMissBoss > 100 then
    rangedMissBoss = 100
    end
self.RangedBoss:SetText("Ranged Miss+: " .. rangedMissBoss .. "%|r");
 
-- Spell Hit Chance
local hitSpellChance = GetSpellHitModifier("player");
hitSpellChance = hitSpellChance + hitMod
self.SpellHit:SetText("Spell Hit: " .. hitSpellChance .. "%" .. labelHit);  
 
-- Spell Miss Chance
local spellSameLevel = 3
local spellBossLevel = 16
spellSameLevel = (spellSameLevel - hitSpellChance)
spellBossLevel = (spellBossLevel - hitSpellChance)
    if spellSameLevel < 0 then
        spellSameLevel = 0
    elseif spellSameLevel > 100 then
        spellSameLevel = 100
    end
    if spellBossLevel < 0 then
        spellBossLevel = 0
    elseif spellBossLevel > 100 then
        spellBossLevel = 100
    end
self.SpellMiss:SetText("Spell Miss: " .. spellSameLevel .. "%");
self.SpellBoss:SetText("Spell Miss+: " .. spellBossLevel .. "%");
                        
 
-- Healing Spell Power
local SinHealSpell = GetSpellBonusHealing();
self.Healing:SetText("Healing: +" .. ("%.0f"):format(SinHealSpell + (SinHealSpell * spiritualHealing) + (SinHealSpell * purification)));    
        
-- Holy Spell Power
local SinHolySpell = GetSpellBonusDamage(2);
if spellCheck() then
SinHolySpell = ((SinHolySpell * 0.1))
end
if dmfDamage(dmfbuff) then
	SinHolySpell = (SinHolySpell + (SinHolySpell * dmfbuff))
end  
self.Holy:SetText("Holy: +" .. ("%.0f"):format(SinHolySpell + (SinHolySpell * vengeance))); 
        
-- Nature Spell Power
local SinNatureSpell = GetSpellBonusDamage(4);
if dmfDamage(dmfbuff) then
	SinNatureSpell = (SinNatureSpell + (SinNatureSpell * dmfbuff))
end  
self.Nature:SetText("Nature: +" .. SinNatureSpell); 
 
-- Shadow Spell Power
local SinShadowSpell = GetSpellBonusDamage(6);
if (classFilename == "WARLOCK") then
if demonicSacrifice(dsSuc) then
    SinShadowSpell = (SinShadowSpell + (SinShadowSpell * dsSuc))
end
end
if dmfDamage(dmfbuff) then
	SinShadowSpell = (SinShadowSpell + (SinShadowSpell * dmfbuff))
end
SinShadowSpell = (SinShadowSpell + (SinShadowSpell * shadowMastery))
self.Shadow:SetText("Shadow: +" .. ("%.0f"):format(SinShadowSpell));        
        
-- Fire Spell Power
local SinFireSpell = GetSpellBonusDamage(3);    
SinFireSpell = (SinFireSpell + (SinFireSpell * firepowerMod) + (SinFireSpell * aiMod) + firepowerMod + (SinFireSpell * emberstorm)) 
if spellCheck() then
SinFireSpell = (SinFireSpell * 0.3)
end 
if (classFilename == "WARLOCK") then
if demonicSacrifice(dsImp) then
    SinFireSpell = (SinFireSpell + (SinFireSpell * dsImp))
end
end
if dmfDamage(dmfbuff) then
	SinFireSpell = (SinFireSpell + (SinFireSpell * dmfbuff))
end 
self.Fire:SetText("Fire: +" .. ("%.0f"):format(SinFireSpell));      
        
-- Frost Spell Power
local SinFrostSpell = GetSpellBonusDamage(5);               
SinFrostSpell = (SinFrostSpell + (SinFrostSpell * pierceMod) + (SinFrostSpell * aiMod))     
if spellCheck() then
SinFrostSpell = (SinFrostSpell * 0.3)
end       
if dmfDamage(dmfbuff) then
	SinFrostSpell = (SinFrostSpell + (SinFrostSpell * dmfbuff))
end  
self.Frost:SetText("Frost: +" .. ("%.0f"):format(SinFrostSpell));   
 
-- Arcane Spell Power
local SinArcaneSpell = GetSpellBonusDamage(7);
SinArcaneSpell = (SinArcaneSpell + (SinArcaneSpell * aiMod))
if spellCheck() then
SinArcaneSpell = (SinArcaneSpell * 0.3)
end
if dmfDamage(dmfbuff) then
	SinArcaneSpell = (SinArcaneSpell + (SinArcaneSpell * dmfbuff))
end  
self.Arcane:SetText("Arcane: +" .. ("%.0f"):format(SinArcaneSpell));   
        
-- Dodge
local dodgeChance = GetDodgeChance("player");
self.Dodge:SetText("Dodge: " .. ("%.2f"):format(dodgeChance) .. "%");       
        
-- Parry
local parryChance = GetParryChance("player");
self.Parry:SetText("Parry: " .. ("%.2f"):format(parryChance) .. "%"); 
 
-- Block
local blockChance = GetBlockChance("player");
self.Block:SetText("Block: " .. ("%.2f"):format(blockChance) .. "%");    
 
local currentSpeed, runSpeed, flightSpeed, swimSpeed = GetUnitSpeed("player")
self.Speed:SetText(string.format("Speed: %d%%", GetUnitSpeed("player") / 7 * 100));
 
 
end)

-------------------------------
-- Redrawing stats on the frame
-------------------------------
 
function SinStats:redrawStats()
    local first, last
    for i=1, #self.Texts do
        if self.Texts[i]:IsShown() then
            self.Texts[i]:ClearAllPoints()
            if not first then
                self.Texts[i]:SetPoint("TOPLEFT")
                first = true
            else
			if SinStatsDB.SinDirection then
				self.Texts[i]:SetPoint("LEFT", last, "RIGHT", 7, 0)	
			elseif not SinStatsDB.SinDirection then
				self.Texts[i]:SetPoint("TOPLEFT", last, "BOTTOMLEFT")
end				
            end
            last = self.Texts[i]
        end
    end
end
 
 
SinStats:SetScript("OnEvent", function (self, event, ...)
local spirit, effectiveSpirit, posBuffSpirit, negBuffSpirit = UnitStat("player", 5)
    if event == "PLAYER_LOGIN" then
    print("|cffea5636SinStats HUD v1.8|r loaded. Type |cff00c0ff/sinstats|r to open the settings.")
    local className, classFilename, classId = UnitClass("player")
    talentScan()
    initSinStatsDB()             
    self:RestiseStats()          
    CreateConfig(self)
    self:redrawStats()
	
StaticPopupDialogs["SINSTATS_APPLY_SETTINGS"] = {
text = "Apply changes and reload ?",
button1 = "Yes",
button2 = "No",
timeout = 0,
whileDead = true,
hideOnEscape = false,		
OnAccept = function(self) ReloadUI() end,
OnCancel = function(self) end, 
}

StaticPopupDialogs["SINSTATS_HUD_RESET"] = {
text = "Apply changes and reload ?",
button1 = "Yes",
button2 = "No",
timeout = 0,
whileDead = true,
hideOnEscape = false,		
OnAccept = function(self) 
SinStatsFrame:SetUserPlaced(false)
SinStatsFrame:ClearAllPoints()
SinStatsFrame:SetPoint("CENTER", 0, 0)
SinStatsFrame:SetUserPlaced(true)
 end,
OnCancel = function(self) end, 
}

    self:GetScript("OnEvent")(self, "UPDATE_INVENTORY_DURABILITY")
    self:GetScript("OnEvent")(self, "UNIT_RESISTANCES")   
    self:GetScript("OnEvent")(self, "UNIT_ATTACK_POWER")
    self:GetScript("OnEvent")(self, "UNIT_RANGED_ATTACK_POWER")
    self:GetScript("OnEvent")(self, "UNIT_DAMAGE")  
    self:GetScript("OnEvent")(self, "UNIT_RANGEDDAMAGE")   
    self:GetScript("OnEvent")(self, "UNIT_DEFENSE")  
    self:GetScript("OnEvent")(self, "UNIT_STATS")       
    self:GetScript("OnEvent")(self, "UNIT_AURA")        
            
    elseif event == "UNIT_DEFENSE" then
    local baseDefense, bonusDefense, posBuff, negBuff = 0,0,0,0
    local DefGear = GetNumSkillLines()
    local DefGearIndex = 0
        for i = 1, DefGear do
        local DefName = select(1, GetSkillLineInfo(i))
        if (DefName == DEFENSE) then
            DefGearIndex = i
        break
        end
        end
        if (DefGearIndex > 0) then
            baseDefense = select(4, GetSkillLineInfo(DefGearIndex))
            bonusDefense = select(6, GetSkillLineInfo(DefGearIndex))
        else
            baseDefense, bonusDefense = UnitDefense("player")
        end
        if ( bonusDefense > 0 ) then
            posBuff = bonusDefense
        elseif ( bonusDefense < 0 ) then
            negBuff = bonusDefense
        end
    self.Defense:SetText("Defense: " .. format("%.0f", (baseDefense + bonusDefense)))           
           
    elseif event == "UNIT_RESISTANCES" then
    local base, bonus, total = UnitResistance("player",2)
    local effectiveFR = bonus
    self.FireResist:SetText("Fire Res: " .. effectiveFR)
           
    local base, bonus, total = UnitResistance("player",5)
    local effectiveSR = bonus
    self.ShadowResist:SetText("Shadow Res: " .. effectiveSR)
           
    local base, bonus, total = UnitResistance("player",4)
    local effectiveFrR = bonus
    self.FrostResist:SetText("Frost Res: " .. effectiveFrR)
           
    local base, bonus, total = UnitResistance("player",3)
    local effectiveNR = bonus
    self.NatureResist:SetText("Nature Res: " .. effectiveNR)   
 
    elseif event == "UPDATE_INVENTORY_DURABILITY" then
        local Durability, Current, Full, Percent
        local LowestCurrent, LowestFull, t1, t2, t3 = 500, 0, 0, 0, 100
        for i=1,19 do
            Current, Full = GetInventoryItemDurability(i)
            if Current and Full then
                Percent = floor(100*Current/Full + 0.5)
                if (Percent < t3) then
                    t3 = Percent
                end
                if (Current < LowestCurrent) then
                    LowestCurrent = Current
                    LowestFull = Full
                end
                t1 = t1 + Current
                t2 = t2 + Full
            end
        end
        if t2 == 0 then
            Durability = "N/A"
        else
                Durability = floor(t1 * 100 / t2)
        end
        local Text = ""
        if type(Durability) == "number" then
        if Durability > 50 then
            Text = string.format("|cff%2xff00", ((Durability > 50) and (255 - 2.55*Durability) or (2.55*Durability)), Durability) .. Text
            else
                Text = string.format("|cffff%2x00", (2.55*Durability), Durability) .. Text
            end
            Text = Text..Durability.."%"
        end
        local Text = "Durability: " .. Text
        self.Durability:SetText(Text)         
        
    elseif event == "UNIT_ATTACK_POWER" then
        local base, posBuff, negBuff = UnitAttackPower("player");
        local effectiveAP = base + posBuff + negBuff;
        self.AP:SetText("AP: " .. effectiveAP); 
    
    elseif event == "UNIT_RANGED_ATTACK_POWER" then
        local base, posBuff, negBuff = UnitRangedAttackPower("player");
        local effectiveRanged = base + posBuff + negBuff;
        self.RAP:SetText("Ranged AP: " .. effectiveRanged);
 
    elseif event == "UNIT_DAMAGE" then
        local lowDmg, hiDmg, offlowDmg, offhiDmg, posBuff, negBuff, percentmod = UnitDamage("player");
        local dmgeffect = hiDmg;
        self.DMG:SetText("Damage: " .. ("%.0f"):format(dmgeffect));
 
    elseif event == "UNIT_RANGEDDAMAGE" then
        local speed, lowDmg, hiDmg, posBuff, negBuff, percent = UnitRangedDamage("player");
        local Rdmgeffect = hiDmg;
        self.RDMG:SetText("Ranged Damage: " .. ("%.0f"):format(Rdmgeffect));    
        
    elseif event == "CHARACTER_POINTS_CHANGED" then
        talentScan()
 
    elseif event == "PLAYER_LEVEL_UP" then
    local playerLevel = UnitLevel("player")
 
    
    else -- Other Events
    
    local base = 0
        if (playerLevel < 19) then
        if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then
            base = ((spirit/2))
        end
        elseif (classFilename == "HUNTER") or (classFilename == "PALADIN") or (classFilename == "WARLOCK") or (classFilename == "SHAMAN") then
            base = ((spirit/5) + 15)
        elseif (classFilename == "PRIEST") or (classFilename == "MAGE") then
            base = ((spirit/4) + 12.5)
        elseif (classFilename == "DRUID") then
                base = ((spirit/5) + 15)
        end 
        
    local mp5 = 0
    local tierPieces = 0
    local zgPieces = 0 
	local pouchCounter = 0
	local atkspeed = 0
    
    if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then
        for i=1,23 do
		
        local itemLink = GetInventoryItemLink("player", i)
            if itemLink then
        local stats = GetItemStats(itemLink)
            if stats then
        local statMP5 = stats["ITEM_MOD_POWER_REGEN0_SHORT"]
		-- local asEnchant = stats["STAT_ATTACK_SPEED_BASE_TOOLTIP"]
            if (statMP5) then
            mp5 = mp5 + statMP5 + 1
            end
			-- if (asEnchant) then
			-- atkspeed = atkspeed + 1
			-- end
            end
        if (classFilename == "PRIEST") or (classFilename == "DRUID") or (classFilename == "PALADIN") or (classFilename == "SHAMAN") then
            local itemName = C_Item.GetItemNameByID(GetInventoryItemLink("player", i))
 
            if itemName then
            if classId == 5 then 
                if string.sub(itemName, -13) == "Transcendence" then
                    tierPieces = tierPieces + 1
                end
            elseif classId == 11 then 
                if string.sub(itemName, 1, 9) == "Stormrage" then
                    tierPieces = tierPieces + 1
                end
                if (string.sub(itemName, 10, 17) == "Haruspex") or 
                (string.sub(itemName, -15) == "South Seas Kelp") or
                (string.sub(itemName, 1, 9) == "Wushoolay") then
                    zgPieces = zgPieces + 1
                end
            elseif classId == 2 then 
                if (string.sub(itemName, 10, 20) == "Freethinker") or 
                (string.sub(itemName, 1, 7) == "Gri'lek") or
                (string.sub(itemName, 1, 12) == "Hero's Brand") then
                    zgPieces = zgPieces + 1
                end
            elseif classId == 7 then 
                if (string.sub(itemName, 1, 5) == "Augur") or 
                (string.sub(itemName, 1, 8) == "Unmarred") or
                (string.sub(itemName, 1, 9) == "Wushoolay") then
                    zgPieces = zgPieces + 1
                end
end
end
end
        if (classFilename == "HUNTER") then
            local itemName = C_Item.GetItemNameByID(GetInventoryItemLink("player", i))
 
            if itemName then
                if (string.sub(itemName, -10) == "Ammo Pouch") or
					(string.sub(itemName, 1, 10) == "Small Shot") or
					(string.sub(itemName, -9) == "Ammo Sack") or
					(string.sub(itemName, -6) == "Quiver") then
						pouchCounter = 10
				elseif (string.sub(itemName, 1, 9) == "Bandolier") or
						(string.sub(itemName, -11) == "Night Watch") then
						pouchCounter = 11
				elseif (string.sub(itemName, 1, 3) == "Heavy Leather") or
						(string.sub(itemName, 1, 12) == "Heavy Quiver") then
						pouchCounter = 12
				elseif (string.sub(itemName, 1, 13) == "Thick Leather") or
						(string.sub(itemName, 1, 9) == "Quickdraw") then
						pouchCounter = 13
				elseif (string.sub(itemName, 1, 8) == "Ribbly's") then
						pouchCounter = 14	
				elseif (string.sub(itemName, 1, 10) == "Gnoll Skin") or 
						(string.sub(itemName, 1, 10) == "Harpy Hide") or
						(string.sub(itemName, -6) == "Lamina") then
						pouchCounter = 15								
                end		        
            end				
				
				
				
            end
            end
        end
    end 
local effectiveMR = mp5 * 0.4       
        
        
    
    local talentRegen = 0
    local totemTalent = 0
    if (classFilename == "MAGE") then
        local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 12) 
            talentRegen = (((base)/100) * (points * 5))
    elseif (classFilename == "DRUID") then
        local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 6) 
            talentRegen = ((base/100) * (points * 5))
    elseif (classFilename == "PRIEST") then
        local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 8) 
            talentRegen = ((base/100) * (points * 5))
    elseif (classFilename == "SHAMAN") then
        local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 12) 
            totemTalent = ((base/100) * (points * 5))
    end 
        
 
    local magearmor = 0
    local evoc = 0  
    local felEnergy = 0 
    local siphonregen = 0
    local siphoncast = 0    
    local innerregen = 0
    local innercast = 0
    local bowisdom = 0
    local wismp5 = 0
    local springtotem = 0
    local tidetotem = 0
    local swregen = 0   
    local fishsoup = 0
    local fishsoupmp5 = 0   
    local warchief = 0
    local mageblood = 0
	local meleeHaste = 100	
	local rangedHaste = 100
	local castHaste = 100
	-- local wickerman = 0
    if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then 
    for i = 1, 40 do
    local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
    if not spellId then break end   
    
        if spellId == 29166 then 
            innerregen = ((base)*4)
            innercast = base    
        end
        
        if spellId == 16609 then 
            warchief = 10
        end 
        
        if spellId == 19742 then 
            bowisdom = (((10 * wisTalent) * 0.4) + (10 * 0.4))
            wismp5 = ((10 * wisTalent)  + 10)
        elseif spellId == 19850 then 
            bowisdom = (((15 * wisTalent) * 0.4) + (15 * 0.4))
            wismp5 = ((15 * wisTalent)  + 15)           
        elseif spellId == 19852 then
            bowisdom = (((20 * wisTalent) * 0.4) + (20 * 0.4))
            wismp5 = ((20 * wisTalent)  + 20)           
        elseif spellId == 19853 then
            bowisdom = (((25 * wisTalent) * 0.4) + (25 * 0.4))
            wismp5 = ((25 * wisTalent)  + 25)   
        elseif spellId == 19854 then 
            bowisdom = (((30 * wisTalent) * 0.4) + (30 * 0.4))
            wismp5 = ((30 * wisTalent)  + 30)           
        elseif spellId == 25290 then 
            bowisdom = (((33 * wisTalent) * 0.4) + (33 * 0.4))
            wismp5 = ((33 * wisTalent)  + 33)   
        elseif spellId == 25894 then 
            bowisdom = (((30 * wisTalent) * 0.4) + (30 * 0.4))
            wismp5 = ((30 * wisTalent)  + 30)       
        elseif spellId == 25918 then
            bowisdom = (((33 * wisTalent) * 0.4) + (33 * 0.4))
            wismp5 = ((33 * wisTalent)  + 33)       
        elseif spellId == 5677 then 
            if totemTalent > 0 then
                springtotem = 4 + totemTalent
            else
                springtotem = 4
            end             
        elseif spellId == 10491 then 
            if totemTalent > 0 then
                springtotem = 6 + totemTalent
            else
                springtotem = 6
            end         
        elseif spellId == 10493 then 
            if totemTalent > 0 then
                springtotem = 8 + totemTalent
            else
                springtotem = 8
            end             
        elseif spellId == 10494 then 
            if totemTalent > 0 then
                springtotem = 10 + totemTalent
            else
                springtotem = 10
            end 
        elseif spellId == 24853 then   
                springtotem = 27    
        elseif spellId == 16191 then 
                tidetotem = 114             
        elseif spellId == 17355 then 
                tidetotem = 154 
        end
    
    if spellId == 18194 then 
        fishsoup = (8 * 0.4)
        fishsoupmp5 = 8 
    end
        
    if spellId == 15604 then 
        swregen = 60        
    end     
    
    if spellId == 24363 then
        mageblood = 12
    end
	
	-- if spellId == 24705 then
		-- wickerman = ((base)*0.25)
	-- end
    
    if (classFilename == "MAGE") then   
        if spellId == 6117 then 
            magearmor = ((base)*0.3)
        elseif spellId == 22782 then    
            magearmor = ((base)*0.3)    
        elseif spellId == 22783 then
            magearmor = ((base)*0.3)    
        elseif spellId == 12051 then 
            evoc = ((base)*15)
        end	
		if spellId == 23723 then
			castHaste = (castHaste + 33)
		end		
		if spellId == 26635 then
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
		if percenthealth > 40 then	
			rangedHaste = (rangedHaste + 10)
			meleeHaste = (meleeHaste + 10)
			castHaste = (castHaste + 10)
		else 
			rangedHaste = (rangedHaste + 30)
			meleeHaste = (meleeHaste + 30)		
			castHaste = (castHaste + 30)			
		end
		end			
    end
	
    if (classFilename == "WARLOCK") then
    local maxpower = UnitPowerMax("player" , mana);
        if spellId == 18792 then 
            felEnergy = ((maxpower * 0.02) / 2)
        end
        if spellId == 18371 then 
            siphonregen = ((base)*2)
            siphoncast = ((base)/2)     
        end    
		if spellId == 16322 then 
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then 
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then
			meleeHaste = (meleeHaste + 65)
		end				
    end 
	
	if (classFilename == "DRUID") then
	if spellCheck() then
		if spellId == 16322 then
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then 
			meleeHaste = (meleeHaste + 65)
		end			
		if spellId == 13494 then 
			meleeHaste = (meleeHaste + 50)
		end
    end
	end
	
	if (classFilename == "HUNTER") then
		if spellId == 16322 then 
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then 
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then 
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then 
			meleeHaste = (meleeHaste + 65)
		end			
		if spellId == 3045 then 
			rangedHaste = (rangedHaste + 40)
		end		
		if spellId == 19552 or spellId == 19553 or spellId == 19554 or spellId == 19555 or spellId == 19556 then -- Improved Hawk
			rangedHaste = (rangedHaste + 30)
		end	
		if spellId == 26635 then
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
		if percenthealth > 40 then	
			rangedHaste = (rangedHaste + 10)
			meleeHaste = (meleeHaste + 10)
			castHaste = (castHaste + 10)
		else 
			rangedHaste = (rangedHaste + 30)
			meleeHaste = (meleeHaste + 30)		
			castHaste = (castHaste + 30)			
		end
		end	
	end	
	
	
	if (classFilename == "PALADIN") then
		if spellId == 16322 then 
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then 
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then 
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then 
			meleeHaste = (meleeHaste + 65)
		end			
		if spellId == 23733 then 
			meleeHaste = (meleeHaste + 25)
			castHaste = (castHaste + 33)
		end		
	end

	if (classFilename == "PRIEST") then
		if spellId == 16322 then 
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then 
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then 
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then 
			meleeHaste = (meleeHaste + 65)
		end			
		if spellId == 26635 then
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
		if percenthealth > 40 then	
			rangedHaste = (rangedHaste + 10)
			meleeHaste = (meleeHaste + 10)
			castHaste = (castHaste + 10)
		else 
			rangedHaste = (rangedHaste + 30)
			meleeHaste = (meleeHaste + 30)		
			castHaste = (castHaste + 30)			
		end
		end	
	end	

	if (classFilename == "SHAMAN") then
		if spellId == 16322 then 
			meleeHaste = (meleeHaste + 3)
		end			
		if spellId == 7396 then 
			meleeHaste = (meleeHaste + 10)
		end		
		if spellId == 16609 then 
			meleeHaste = (meleeHaste + 15)
		end		
		if spellId == 15167 then 
			meleeHaste = (meleeHaste + 65)
		end			
		if spellId == 26635 then
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
		if percenthealth > 40 then	
			rangedHaste = (rangedHaste + 10)
			meleeHaste = (meleeHaste + 10)
			castHaste = (castHaste + 10)
		else 
			rangedHaste = (rangedHaste + 30)
			meleeHaste = (meleeHaste + 30)		
			castHaste = (castHaste + 30)			
		end
		end	
	end	
	
	
end
end

if (classFilename == "WARRIOR") then
for i = 1, 40 do
    local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
    if not spellId then break end   
	
	if spellId == 12966 then 
		meleeHaste = (meleeHaste + 10)
	elseif spellId == 12967 then 
		meleeHaste = (meleeHaste + 15)
	elseif spellId == 12968 then 
		meleeHaste = (meleeHaste + 20)
	elseif spellId == 12969 then 
		meleeHaste = (meleeHaste + 25)	
	elseif spellId == 12970 then 
		meleeHaste = (meleeHaste + 30)
	end
	if spellId == 16322 then 
		meleeHaste = (meleeHaste + 3)
	end			
	if spellId == 7396 then 
		meleeHaste = (meleeHaste + 10)
	end		
	if spellId == 16609 then
		meleeHaste = (meleeHaste + 15)
	end		
	if spellId == 15167 then 
		meleeHaste = (meleeHaste + 65)
	end		
	if spellId == 26635 then 
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
	if percenthealth > 40 then	
		rangedHaste = (rangedHaste + 10)
		meleeHaste = (meleeHaste + 10)
		castHaste = (castHaste + 10)		
	else 
		rangedHaste = (rangedHaste + 30)
		meleeHaste = (meleeHaste + 30)	
		castHaste = (castHaste + 30)		
	end
	end	
end
	
elseif (classFilename == "ROGUE") then
for i = 1, 40 do
    local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
    if not spellId then break end   
	
	if spellId == 5171 then 
		meleeHaste = (meleeHaste + 20)
	elseif spellId == 6774 then 
		meleeHaste = (meleeHaste + 30)
	end
	if spellId == 13877 then 
		meleeHaste = (meleeHaste + 20)
	end
	if spellId == 16322 then 
		meleeHaste = (meleeHaste + 3)
	end		
	if spellId == 7396 then 
		meleeHaste = (meleeHaste + 10)
	end			
	if spellId == 16609 then 
		meleeHaste = (meleeHaste + 15)
	end	
	if spellId == 15167 then 
		meleeHaste = (meleeHaste + 65)
	end	
	if spellId == 26635 then
		local health = UnitHealth("player")
		local max_health = UnitHealthMax("player")
		local percenthealth = ((health/max_health) * 100)
	if percenthealth > 40 then	
		rangedHaste = (rangedHaste + 10)
		meleeHaste = (meleeHaste + 10)
		castHaste = (castHaste + 10)		
	else 
		rangedHaste = (rangedHaste + 30)
		meleeHaste = (meleeHaste + 30)	
		castHaste = (castHaste + 30)		
	end
	end	
end
end

local hasteHead = 0
local hasteLegs = 0
local hasteHands = 0
local slotId = GetInventorySlotInfo("HandsSlot")
local link = GetInventoryItemLink("player", slotId)
-- print("link", link)
    if link then
        local itemId, enchantId = link:match("item:(%d+):(%d+)")
            if enchantId then
                enchantId = tonumber(enchantId)
				-- print("enchantId", enchantId, enchantId == 931)
                    if enchantId == 931 then
						hasteHands = hasteHands + 1
                    end
            end
    end
local slotId = GetInventorySlotInfo("HeadSlot")
local link = GetInventoryItemLink("player", slotId)
    if link then
        local itemId, enchantId = link:match("item:(%d+):(%d+)")
            if enchantId then
                enchantId = tonumber(enchantId)
                    if enchantId == 2543 then
						hasteHands = hasteHands + 1
                    end
            end
    end	
local slotId = GetInventorySlotInfo("LegsSlot")
local link = GetInventoryItemLink("player", slotId)
    if link then
        local itemId, enchantId = link:match("item:(%d+):(%d+)")
            if enchantId then
                enchantId = tonumber(enchantId)
                    if enchantId == 2543 then
						hasteHands = hasteHands + 1
                    end
            end
    end		
self.HasteMelee:SetText("Haste: " .. meleeHaste + hasteHands .. "%")  
self.HasteRanged:SetText("Ranged Haste: " .. rangedHaste + pouchCounter + hasteHands .. "%") 
self.HasteCaster:SetText("Spell Haste: " .. castHaste .. "%")  

	
local oilEnchants = 0
local oilRegen = 0
if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") and (classFilename ~= "HUNTER") then
local hasMainHandEnchant, _, _, mainHandEnchantID, _, _, _, _ = GetWeaponEnchantInfo()
    if hasMainHandEnchant then
        if mainHandEnchantID == 2624 then
            oilEnchants = 4
            oilRegen = oilEnchants * 0.4
        elseif mainHandEnchantID == 2625 then
            oilEnchants = 8
            oilRegen = oilEnchants * 0.4    
        elseif mainHandEnchantID == 2629 then
            oilEnchants = 12
            oilRegen = oilEnchants * 0.4            
        end
    end
end 
    
    local tierBonus = 0
    if tierPieces >= 3 then
        tierBonus = ((base) * 0.15)
	end
    local zgMP5 = 0 	
    if zgPieces >= 2 then
        zgMP5 = 4
    end         
 
    
self.ManaRegen:SetText("Mana Regen: " .. format("%.0f", (base) + effectiveMR + innerregen + evoc + bowisdom + fishsoup + springtotem + tidetotem + siphonregen + swregen + felEnergy + oilRegen + (warchief * 0.4) + (mageblood * 0.4) + (zgMP5 * 0.4)))
self.CastingRegen:SetText("Casting Regen: " .. format("%.0f", effectiveMR + innercast + magearmor + talentRegen + bowisdom + fishsoup + springtotem + tidetotem + siphoncast + tierBonus + swregen + felEnergy + (warchief * 0.4) + (mageblood * 0.4) + oilRegen + (zgMP5 * 0.4)))         
self.MP5Cast:SetText("MP5: " .. format("%.0f", (mp5) + wismp5 + fishsoupmp5 + zgMP5 + oilEnchants + warchief + mageblood)) 
end        
end)  
-------------------------------------------
-- Slash command to open the Settings frame
-------------------------------------------
SLASH_SINSTATS1 = "/sinstats"
function SlashCmdList.SINSTATS()
  if (SinStatsConfigFrame:IsVisible()) then
      HideUIPanel(SinStatsConfigFrame);
  else
      ShowUIPanel(SinStatsConfigFrame);
  end
end
